import pygame

#Screen resolution and mode
screen_w = 1024 # pixels
screen_h = 768  # pixels
screen_size = (screen_w, screen_h) # (pixels, pixels)

fullscreen  = False

invisible_color = (20, 20, 20) # RGB

# Game speed
framerate  = 60   # fps

# Key settings
key_left   = [pygame.K_LEFT, pygame.K_a, pygame.K_z]
key_right  = [pygame.K_RIGHT, pygame.K_d, pygame.K_x]
key_attack = [pygame.K_UP, pygame.K_w, pygame.K_c]

# Depth
z_distance = 1000 # miliseconds, too big?
background_z_range = (100, 200)
foreground_z_range = (750, 850)
background_z_center = 150
foreground_z_center = 800
z_difference        = foreground_z_center - background_z_center

castle_x_range = (200, 860)

# Player stats
player_speed      = (0.25 * screen_w) / 1000.0 # Pixels/second
player_hitpoints  = 15
player_lives      = 1
player_fire_delay = 200 #miliseconds

player_spritesheet = "heroine.png"

player_w = 128  # pixels
player_h = 128 # pixels
player_size = (player_w, player_h) # (pixels, pixels)

p_animations = {
    "idle"   : ([0], 100),
    "right"  : ([1,2,3,2], 100),
    "left"   : ([4,5,6,5], 100),
    "idle2"  : ([7], 100),
    "right2" : ([8,9,10,9], 100),
    "left2"  : ([11,12,13,12], 100),
    "catch"  : ([14,15,16], 100),
    "attack" : ([17,18,19,19], 100),
    "hit"    : ([20,21,22,21,20,21,22], 75),
    "dying"  : ([2,2,2], 100),
}

# Archer stats
archer_speed         = (0.05 * screen_w) / 1000.0 # Pixels/second
archer_hitpoints     = 2
archer_fire_delay    = 200
archer_fire_cooldown = 2500

archer_spritesheet = "archer.png"

archer_w = 64
archer_h = 64
archer_size = (archer_w, archer_h)

archer_y = 150

archer_inaccuracy = 40

a_animations = {
    "arrive" : ([14,15,16], 100),
    "idle"   : ([0,1,2,1], 100),
    "right"  : ([0,1,2,1], 100),
    "left"   : ([0,1,2,1], 100),
    "attack" : ([3,4,5], 100),
    "hit"    : ([6,7,8,7,6,7,8], 75),
    "dying"  : ([9,10,11,12,13], 75),
}

# Strong Archer stats
s_archer_speed         = (0.05 * screen_w) / 1000.0 # Pixels/second
s_archer_hitpoints     = 4
s_archer_fire_delay    = 200
s_archer_fire_cooldown = 3000

s_archer_inaccuracy = 80

sa_animations = {
    "arrive" : ([34,35,36], 100),
    "idle"   : ([20,21,22,21], 100),
    "right"  : ([20,21,22,21], 100),
    "left"   : ([20,21,22,21], 100),
    "attack" : ([23,24,25], 100),
    "hit"    : ([26,27,28,27,26,27,28], 75),
    "dying"  : ([29,30,31,32,33], 75),
}

# Quick Archer stats
q_archer_speed         = (0.1 * screen_w) / 1000.0 # Pixels/second
q_archer_hitpoints     = 1
q_archer_fire_delay    = 200
q_archer_fire_cooldown = 1000

q_archer_inaccuracy = 80

qa_animations = {
    "arrive" : ([54,55,56], 100),
    "idle"   : ([40,41,42,41], 100),
    "right"  : ([40,41,42,41], 100),
    "left"   : ([40,41,42,41], 100),
    "attack" : ([43,44,45], 100),
    "hit"    : ([46,47,48,47,46,47,48], 75),
    "dying"  : ([49,50,51,52,53], 75),
}

# Elite Archer stats
e_archer_speed         = (0.1 * screen_w) / 1000.0 # Pixels/second
e_archer_hitpoints     = 4
e_archer_fire_delay    = 200
e_archer_fire_cooldown = 800

e_archer_inaccuracy = 10

ea_animations = {
    "arrive" : ([74,75,76], 100),
    "idle"   : ([60,61,62,61], 100),
    "right"  : ([60,61,62,61], 100),
    "left"   : ([60,61,62,61], 100),
    "attack" : ([63,64,65], 100),
    "hit"    : ([66,67,68,67,66,67,68], 75),
    "dying"  : ([69,70,71,72,73], 75),
}

# King Archer stats
k_archer_speed         = (0.15 * screen_w) / 1000.0 # Pixels/second
k_archer_hitpoints     = 7
k_archer_fire_delay    = 200
k_archer_fire_cooldown = 800

k_archer_inaccuracy = 10

ka_animations = {
    "arrive" : ([94,95,96], 100),
    "idle"   : ([80,81,82,81], 100),
    "right"  : ([80,81,82,81], 100),
    "left"   : ([80,81,82,81], 100),
    "attack" : ([83,84,85], 100),
    "hit"    : ([86,87,88,87,86,87,88], 75),
    "dying"  : ([89,90,91,92,93], 75),
}


# Missile stats
missile_w = 128
missile_h = 128
missile_sizes = [(int(missile_w*scale/100.0), int(missile_h*scale/100.0)) for scale in range(5, 101, 5)]
print missile_sizes

arrow_damage = 1

# Sprite and character States
state_idle       = 0
state_arrive     = 1
state_walkleft   = 2
state_walkright  = 3
state_attack     = 4
state_get_hit    = 5
state_dying      = 6
state_deleting   = 7
state_catch      = 8
state_idle2      = 9
state_walkleft2  = 10
state_walkright2 = 11
numstates        = 12